class bar{
   attributes
      Real E, Sy, L, W, H, F_bn,F_bk, F_t, Sigma, I, F;
   constraints
          I = F_bk * L *L /3.141 * 3.141*E; 
I = W * H * H * H / 12; 
F_t = (Sy * (W * H)); 
Sigma = (((H * L) * F_bn )/ (8 * I)); 
F_t = F :- F > 0; 
F_bk = F :- F < 0;
   constructors bar(E1,Sy1,L1,W1,H1,F_bn1,F_bk1,F_t1,Sigma1,I1,F1){
      E=E1; Sy=Sy1;L=L1; H=H1; W=W1; F_bn=F_bn1;
      F_bk=F_bk1; F_t=F_t1; Sigma=Sigma1;I=I1; F=F1;
   }
}



class beam{
   attributes
      bar B;
      Real A;
   constraints
          A >= 0;   A <= 2* 180;
   constructors beam(B1, A1){
     B = B1; A = A1;
   }
}



class joint{
   attributes
      beam[] Beams;
      load[] Loads;
   constraints
          (sum X in Beams: (X.B.F * sin(X.A))) + sum X in Loads: (X.F *
          sin(X.A)) = 0; 
(sum X in Beams: (X.B.F * cos(X.A))) + sum X in Loads: (X.F * cos(X.A)) = 0;
   constructors joint(B1, L1){
Beams = B1;
      Loads = L1;
      }
}



class load{
   attributes
      Real F;
      Real A;
  constraints
       A >= 0; A <= 2*180;
   constructors load(F1, A1){
      F =F1;
      A = A1;
   }
}



class sampletruss{ 
attributes 
bar B1, B2, B3, B4, B5;
beam IB1, I1B, IB2, I2B, IB3, I3B, IB4, I4B, IB5, I5B;
load IJ5H, IJ5V, IJ12V, IJ16V;
beam [] BA5, BA12, BA15, BA16;
load [] L5, L12, L16;
Real Esteel, Sy, Pi; 
Real W1, H1, F1, F1_bk, F1_bn, F1_t, Sigma1, I1, W2, H2, F2, F2_bk, F2_bn, F2_t,
Sigma2, I2, W3, H3, F3, F3_bk, F3_bn, F3_t, Sigma3, I3, W4, H4, F4, F4_bk,
F4_bn, F4_t, Sigma4, I4, W5, H5, F5, F5_bk, F5_bn, F5_t, Sigma5, I5;
Real FJ5H, FJ5V, FJ12V, FJ16V;
joint J5, J12, J15, J16;
constraints 
 ESteel = 30000000;
 Sy = 30000;
Pi = 3.141; 
 W1 = H1;W2 = H2;W3 = H3;W4 = H4;W5 = H5;
constructors sampletruss(X) {
B1 = new bar(ESteel, Sy, 10.4, W1, H1, F1_bn, F1_bk, F1_t, Sigma1, I1, F1);
B2 = new bar(ESteel, Sy, 7.3, W2, H2, F2_bn, F2_bk, F2_t, Sigma2, I2, F2);
B3 = new bar(ESteel, Sy, 7.3, W3, H3, F3_bn, F3_bk, F3_t, Sigma3, I3, F3);
B4 = new bar(ESteel, Sy, 12.7, W4, H4, F4_bn, F4_bk, F4_t, Sigma4, I4, F4);
B5 = new bar(ESteel, Sy, 14.7, W5, H5, F5_bn, F5_bk, F5_t, Sigma5, I5, F5);
IB1 = new beam( B1, 0.25*Pi);
IB2 = new beam( B2, 0.0*Pi);
IJ5H = new load(FJ5H, 0);IJ5V = new load(FJ5V, Pi/2);BA5 = [IB1, IB2];
L5 = [  IJ5V, IJ5H];
J5 = new joint(BA5, L5);
I2B = new beam( B2, 1.0*Pi);
IB3 = new beam( B3, 0.5*Pi);
IB4 = new beam( B4, 0.0*Pi);
IJ12V = new load(15000, 1.5*Pi);BA12 = [I2B, IB3, IB4];
L12 = [  IJ12V];
J12 = new joint(BA12, L12);
I1B = new beam( B1, 1.25*Pi);
I3B = new beam( B3, 1.5*Pi);
IB5 = new beam( B5, 1.8333334*Pi);
BA15 = [I1B, I3B, IB5];
L15 = [];
J15 = new joint(BA15, L15);
I4B = new beam( B4, 1.0*Pi);
I5B = new beam( B5, 0.8333333*Pi);
IJ16V = new load(FJ16V, Pi/2);BA16 = [I4B, I5B];
L16 = [  IJ16V];
J16 = new joint(BA16, L16);
X = [F1, F2, F3, F4, F5, FJ5H, FJ5V, FJ12V, FJ16V];

}
}

$
